#include "phasedisp.h"

#include <QImage>
#include <vector>
#include <QTextStream>

#define OFFSETH 10

phasedisp::phasedisp()
{
  plot_height=208;
  plot_width=302;
  imgh=302;
  imgw=302;
 
  image = new QImage(imgw, imgh, QImage::Format_RGB32);
  plot = new QImage(plot_width+2, plot_height+2, QImage::Format_RGB32);
  inicond();
  x = 256;
  y = 256;

  imgx=560;
  imgy=20;
}

void phasedisp::update_vec(double u, double v)
{
  u_vec.push_front(u);
  v_vec.push_front(v);

  if (u_vec.size()>300)
  {
    u_vec.pop_back();
    v_vec.pop_back();   
  }  
}

void phasedisp::update_image()
{
  QRgb value;

  value = qRgb(250, v_vec.front()*255, u_vec.front()*250);

	if (v_vec.front()<=1 && u_vec.front()<=1 && 0<v_vec.front() && 0<u_vec.front())
	{
  		image->setPixel(u_vec.front()*300,300-v_vec.front()*300, value);
	}
  
  int limit=180;

  if (u_vec.size()>limit)
  {
    value = qRgb(0, 0, 0); 

	if (u_vec[limit]<1 && v_vec[limit]<1 && 0<u_vec[limit] && 0<v_vec[limit])
	{
    	image->setPixel(u_vec[limit]*300,300-v_vec[limit]*300, value);
	}
  }
}

void phasedisp::update_plot()
{
  QRgb value;
  value = qRgb(250, 250, 250);

  // REVERTING TO INITIAL CONDITIONS
  for (int xx=0; xx<plot_width; xx++)
  {
    for (int yy=0; yy<plot_height; yy++)
    {
        QRgb value;
        value = qRgb(0, 0, 0);

        plot->setPixel(xx, yy, value);
    }
  }
  
  for (int ii=0; ii<u_vec.size(); ii++)
  {
    if (ii<plot_width)
    {
		if (0<u_vec[ii] && u_vec[ii]<1 && 0<v_vec[ii] && v_vec[ii]<1)
		{
			value = qRgb(0, 0, 250);
			plot->setPixel(ii, plot_height- (u_vec[ii]*plot_height), value);
			value = qRgb(0, 250, 0);
			plot->setPixel(ii,plot_height- (v_vec[ii]*plot_height), value);
		}
    }
  }
}

void phasedisp::inicond() 
{
  // REVERTING TO INITIAL CONDITIONS
  for (int xx=1; xx<300; xx++)
  {
    for (int yy=1; yy<300; yy++)
    {
        QRgb value;
        value = qRgb(0, 0, 0);

        image->setPixel(xx, yy, value);
    }
  }
}

void phasedisp::change_point(int xp, int yp)
{
  x=xp;
  y=yp;
}
