#ifndef WAVEFRONT_H
#define WAVEFRONT_H

#include "wavespace.h"
#include "phasedisp.h"
#include "timer.h"
#include <QWidget>
#include <QKeyEvent>
#include <QPushButton>
#include <QString>
#include <QLineEdit>
#include <QMainWindow>
#include <QTime>
#include <QLabel>
#include <QSlider>
#include <string>
#include <QCheckBox>

class wavefront : public QMainWindow
{
    Q_OBJECT

  public:
    wavefront(QWidget *parent = 0);
    ~wavefront();

  protected:
    void paintEvent(QPaintEvent *event);
    void timerEvent(QTimerEvent *event);
    void keyPressEvent(QKeyEvent *event);
    void mousePressEvent(QMouseEvent *event);

  private slots:
    void startWave();
    void resetWave();
	void resetClear();
	void resetPointstim();
    void changeView();
    void setparam();
	void set_static_noise();
	void noise_intencity_alterer();
	void time_step_alterer();
	void M_alterer();
	void set_methodee();
	void set_methodie();
	void set_methodsh();
	void set_methodel();
	void set_methodIFRK4();
	void set_reactionstd();
	void set_reactiondel();
	void set_reactionbareisw();
	void setVisuals();

  private:
	QTime global_timer;
    QLineEdit * eps_edit;
    QLineEdit * b_edit;
    QLineEdit * a_edit;
    QLineEdit * D_edit;
	QLineEdit * Dv_edit;
	QLineEdit * L_edit;
    QPushButton * start_button;
	QPushButton * static_noise_button;
    QPushButton * reset_button;
    QPushButton * view_button;
    QPushButton * new_para;
	QPushButton * change_methods;
	QPushButton * change_reaction_kinetics;
	QSlider * noise_intencity_slider; 
	QLabel * noise_intencity_label;
	QLabel * noise_intencity_label2;
	QSlider * time_step_slider;
	QSlider * M_slider;
	QLabel * M_label;
	QLabel * M_label2;
	QLabel * time_label;
	QLabel * time_label2;
	QLabel * average_iter_rate_label;
	QLabel * elapsed_real_time;
	QLabel * elapsed_virtual_time;
    int timerId;
    bool running;
	int noise_intencity;
    wavespace * space;
    phasedisp * disp;
    int view;
    QPoint mousepos;
	int iter;
	bool static_noise_is_present;
	timer runTimer;
	void set_temporal_info();
	float virtual_time;
	QString solution_method;
	QString reaction_kinetics;
	bool visuals;
	QCheckBox * visualsBox;
};

#endif
