#ifndef WAVESPACE_H
#define WAVESPACE_H


#include <QImage>
#include <QRect>
#include <QLineEdit>
#include <fftw3.h>
#include <QString>
#include <iostream>

#ifndef spat_dist
#define spat_dist 512
#endif

class wavespace
{
  public:
    wavespace();
    ~wavespace();

    QRect getRect();
    void setRect(QRect);
    QImage & getImage();
    void update_space(double intencity,int seed,QString solution_method,QString reaction_kinetics);
	void spectral_update_space(double intencity,int seed,QString reaction_kinetics);
    QImage * image;
    double getu(int xx,int yy){ return u_space[xx][yy];};
    double getv(int xx,int yy){ return v_space[xx][yy];};
    void inicond();
    void set_param(float new_eps, float new_b,float new_a, float new_D, float new_Dv, int new_L);
    int image_x, image_y;
    double g_reaction(double u,double v,QString reaction_kinetics);
    double F_implicit_standard(double u, double gamma);
    double F_explicit(double u, double gamma);
	void passive_diffusion_5point(double Dd,double & u_new,int xx, int yy);
	void passive_diffusion_5point_v(double Dd,double & u_new,int xx, int yy);
	void passive_diffusion_9point(double & u_new,int xx, int yy);
  	void distribute_inxtblty(bool really,int noise_intencity); 
	float get_dt();
	void set_dt(float a);
	void set_M(int a);
	void set_value(double u, double v, int x, int y);
	bool periodicity;
	void eulerlawson_update_space(double intencity, int seed,QString reaction_kinetics);
	void clear();
	void clear_boundary();
	void add_noise(double intencity, int seed);
	double user_f(double u,double v);
	double user_g(double u,double v);
	void IFRK4(double intencity,int seed);

	friend class wavefront;

private:
	fftw_plan transform, transform_inverse, frec_plan;
	fftw_plan FUV2UV, FF12F1, iFUVn2iUVn, FF22F2, FF32F3, FF42F4, iFUV2U;
	fftw_complex * UV, * UVn, * iUVn, * F1, * F2, * F3, * F4;

    float eps,b,a,D,dt, Dv, dx, spatialCorr;
	int M, L;
    QLineEdit *eps_edit;   
	fftw_complex *fourier_space, *fourier_space_frec;

	double av[spat_dist*spat_dist];
	double eig[spat_dist*spat_dist];

    double u_space[spat_dist][spat_dist];
    double v_space[spat_dist][spat_dist];
	bool inexfield[spat_dist][spat_dist];	
	void createEigenvalues(double * lambda);
};

#endif
